#!/usr/bin/env python
# coding: utf-8

"""
12.3 Data Formatting
(p.194 ~ p.197)
"""

# In[1]: p.194
import numpy as np
import pandas as pd
price = np.random.randint(100, size=8)*10000
cars = pd.DataFrame(price, columns=['price'])
cars


# In[2]: p.195
import numpy as np
import pandas as pd
price = np.random.randint(100, size=8)*10000
cars = pd.DataFrame(price, columns=['price'])

group_names = ['??, '중급', '고급']
cars['Level'], mybin = pd.cut(cars['price'], 3, labels=group_names, retbins=True)
cars


# In[3]:
cars['Level'] = pd.cut(cars['price'], 3, labels=group_names)


# In[4]:
cars['Level'], mybin = pd.cut(cars['price'], 3, labels=group_names,
retbins=True)


# In[5]: p.196
print(mybin)


# In[6]:
import pandas as pd
import numpy as np
ary = [[1, 1.1, '??], [2, 2.2, '?개'], [3, 3.3, '??]]
data = pd.DataFrame(ary, columns=['?온', '?온', 'hand'])
pd.get_dummies(data['hand'])


# In[7]: p.197
import pandas as pd
import numpy as np
ary = [[1, 1.1, '??], [2, 2.2, '?개'], [3, 3.3, '??]]
data = pd.DataFrame(ary, columns=['?온', '?온', 'hand'])
data = pd.concat([data, pd.get_dummies(data['hand'])], axis=1, sort=False)
data


# In[8]:
import pandas as pd
import numpy as np
ary = [[1, 1.1, '??], [2, 2.2, '?개'], [3, 3.3, '??]]
data = pd.DataFrame(ary, columns=['?온', '?온', 'hand'])
data = pd.concat([data, pd.get_dummies(data['hand'])], axis=1, sort=False)
data.drop(['hand'], axis=1, inplace=True)
data

